//
//  FForest.java
//  Forest
//
//  Created by Leonardo Yamasaki Maza on 16/06/08.
//  Copyright 2008 Leonardo Yamasaki Maza. All rights reserved.
//

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;
import java.util.*;
import java.net.*;
import javax.swing.Timer;

/////////////////////
public class FForest extends JFrame implements ActionListener{
	JPanel world;
	JPanel header;
	JPanel footer;

	JButton Start;
	JButton Reset;
	
	String strStart=new String("Comenzar");
	String strStop=new String("Parar");
	String strReset=new String("Restablece");
	String strScenary = new String("Escenario:");
	String strSeedTrees = new String("Siembra arboles, salvemos nuestro planeta");
	String strCopyright = new String("(c) 2008, Leonardo Yamasaki");
	
	JComboBox Scenary = new JComboBox();
	
	String Optimista = new String("Optimista f/p>0.1");
	String Neutro = new String("Neutro f/p=0.1");
	String Pesimista = new String("Pesimista f/p<0.1");
	
	Random rand = new Random();
	Timer runtimer;
	Color State0color = Color.red;
	Color State1color = Color.green;
	Color State2color = Color.white;
	
	int SIZE=50;
	int CELLDIMX=15;
	int CELLDIMY=15;
	int MAXPOPTREE=50;
	
	int FIRE=100;         //probability of 10 between 1 000 000 of a fire
	int BORN=10000;      //probability of 10 000 between 1 000 000 of born new tree
	int TIMEPERIOD=200;  //time ratio to events in miliseconds
	
	ImageIcon TreeIcon = new ImageIcon(getClass().getResource("tree-icon.gif"));
	ImageIcon LandIcon = new ImageIcon(getClass().getResource("land-icon.gif"));
	ImageIcon TreeFireIcon = new ImageIcon(getClass().getResource("fire-icon.gif"));
	Cell[][] cell= new Cell[SIZE][SIZE];
	
	public static boolean FFon=false;
	
	/////////////////////////////////////////////////////////
	// Constructor
	/////////////////////////////////////////////////////////
	public FForest(String title){
		super(title);
		JPanel world = new JPanel(true);
		JPanel header = new JPanel();
		JPanel footer = new JPanel();
		JComboBox scenary = new JComboBox();
		
		header.setLayout(new GridLayout(1,1,0,0));
		header.add(new JLabel(title));
		
		Start = new JButton(strStart);
		Start.addActionListener(this);
		header.add(Start);
		
		Reset = new JButton(strReset);
		Reset.addActionListener(this);
		header.add(Reset);
		
		Scenary.addItem(Optimista);
		Scenary.addItem(Neutro);
		Scenary.addItem(Pesimista);
		Scenary.setSelectedIndex(1);
		Scenary.addActionListener(this);
		
		footer.setLayout(new GridLayout(2,1,0,0));
		footer.add(new JLabel(strScenary));
		footer.add(Scenary);
		footer.add(new JLabel(strSeedTrees));
		footer.add(new JLabel(strCopyright));
		
		world.setLayout(new GridLayout(SIZE,SIZE,0,0));
		
		for(int x = 0; x <  SIZE; x++){
			for(int y=0; y < SIZE; y++){
				cell[x][y] = new Cell();
				cell[x][y].setPreferredSize(new Dimension(CELLDIMX, CELLDIMY));
//				cell[x][y].setBorder(BorderFactory.createLineBorder(Color.black));
				cell[x][y].setOpaque(true);
				//set initial state
				initCellState(x,y);
				world.add(cell[x][y]);
			}
		}
		Container cp =  this.getContentPane();
		cp.setLayout(new BorderLayout());
		cp.add(header,BorderLayout.NORTH);
		cp.add(world,BorderLayout.CENTER);
		cp.add(footer,BorderLayout.SOUTH);
		this.setSize((SIZE*CELLDIMX),(SIZE*CELLDIMY));
		FForest.FFon=true;
		this.setVisible(true);
		this.setResizable(false);
	}
	
	////////////////////////////
	public void actionPerformed(ActionEvent ae){
		if (ae.getSource()==Start && Start.getText()==strStart) {
				Start.setText(strStop);
				Reset.setEnabled(false);
				Scenary.setEnabled(false);
				runtimer = new Timer (TIMEPERIOD, new ActionListener () 
				{ 
					public void actionPerformed(ActionEvent e) 
					{ 
						doSimulation();
					} 
				});
			runtimer.start();
			}
		else 
		    {
				Start.setText(strStart);
				Reset.setEnabled(true);
				Scenary.setEnabled(true);
				runtimer.stop();
			}
		if (ae.getSource() == Reset) {
			cellsReset();
		} 
		else
			if (ae.getSource()==Scenary) {
				if (Scenary.getSelectedItem().toString()==Optimista) {				
					FIRE=10;
				}
				else
					if (Scenary.getSelectedItem().toString()==Neutro) {
						FIRE=100;
					}
				else
					if (Scenary.getSelectedItem().toString()==Pesimista) {
						FIRE=1000;
					}
			
			}
	}//end actinperformed
	
	///////////////////////////////////////////////////////////
	void initCellState(int x, int y){
		int r = rand.nextInt(100);
		if (r>0 && r<MAXPOPTREE) {
			cell[x][y].InitState(1);
			cell[x][y].setBackground(State1color);
			cell[x][y].setIcon(TreeIcon);
//			cell[x][y].setText("1");
		}
		else {
			cell[x][y].InitState(2);
			cell[x][y].setBackground(State2color);
			cell[x][y].setIcon(null);
//			cell[x][y].setText("");
		}
	}
	
	/////////////////////////////////////////////////////////
	void cellsReset(){
		for(int x = 0; x <  SIZE; x++){
			for(int y=0; y < SIZE; y++){
				initCellState(x,y);
			}
		}
	}
	
	/////////////////////////////////////////////////////////
	void cellsNewTime(){
		for(int x = 0; x <  SIZE; x++){
			for(int y=0; y < SIZE; y++){
				cell[x][y].NewTime();
			}
		}
	}
		
	/////////////////////////////////////////////////////////
	void doSimulation(){
		int pf=0;
		int pp=0;
		int sum=0;
		for(int x=0; x <  SIZE; x++){
			for(int y=0; y < SIZE; y++){
				pf = rand.nextInt(1000000);
				pp = rand.nextInt(1000000);
				switch (cell[x][y].getState()) {
				case 0: //fire tree
					changeState(x,y,2);
					break;
				case 1: // tree
					sum = getNeighbor(x,y,2) + getNeighbor(x,y,4) + getNeighbor(x,y,6) + getNeighbor(x,y,8);
					if (sum > 0 || pf < FIRE) {
						changeState(x,y,0);
					}
					break;
				case 2://land no tree
					if (pp < BORN) {
						changeState(x,y,1);
					}
					break;
				}
			}
		}
		paintWorld();
		cellsNewTime();
	}
	
	/////////////
	int getNeighbor(int x,int y, int num){
		int temp=0;
		switch (num) {
		case 1:
			temp = getNStat(x-1,y-1);
			break;
		case 2:
			temp = getNStat(x,y-1);
			break;
		case 3:
			temp = getNStat(x+1,y-1);
			break;
		case 4:
			temp = getNStat(x-1,y);
			break;
		case 5:
			temp = getNStat(x,y);
			break;
		case 6:
			temp = getNStat(x+1,y);
			break;
		case 7:
			temp = getNStat(x-1,y+1);
			break;
		case 8:
			temp = getNStat(x+1,y+1);
			break;
		}
		return temp;
	}

	/////////////
	int getNStat(int x, int y){
		int r=0;
		if (x<0 || y<0 || x>=SIZE || y>=SIZE) {
			r = 0;
		}
		else if (cell[x][y].getState()==0) {
			r=1;
		}
		return r;
	}

	/////////////	
	void changeState(int x, int y, int state){
		switch (state) {
		case 0:
			cell[x][y].setState(0);
			cell[x][y].setBackground(State0color);
			cell[x][y].setIcon(TreeFireIcon);
//			cell[x][y].setText("0");
			break;
		case 1:
			cell[x][y].setState(1);
			cell[x][y].setBackground(State1color);
			cell[x][y].setIcon(TreeIcon);
//			cell[x][y].setText("1");
			break;
		case 2:
			cell[x][y].setState(2);
			cell[x][y].setBackground(State2color);
			cell[x][y].setIcon(null);
//			cell[x][y].setText("");
			break;
		}
	}
	
	////////////
	void paintWorld(){
		this.getContentPane().paintComponents(getContentPane().getGraphics());
	}
	
}//End Class