//
//  Forest.java
//  Forest
//
//  Created by Leonardo Yamasaki Maza on 26/05/08.
//  Copyright (c) 2008 Leonardo Yamasaki. All rights reserved.
//  A simple Cellular Automata Java applet
//

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;
import java.util.*;
import java.net.*;

//////////////////////////////////////////////////////////////
//Cell class used for the world of forest cellular automata
class Cell extends JLabel{
	int state;
	int oldstate;
	int stree;
	int oldstree;
	void InitState(int i){
		state=i;
		oldstate=i;
	}
	void InitSTree(int i){
		stree=i;
		oldstree=i;
	}
	void setState(int i){
		state = i;
	}
	int getState(){
		return oldstate;
	}
	void setSTree(int i){
		stree = i;
	}
	int getSTree(){
		return oldstree;
	}
	void NewTime(){
		oldstate=state;
		oldstree=stree;
	}

} // End Clas Cell


//////////////////////////////////////////////////////////////
// Main class 
public class Forest extends JApplet implements ActionListener, WindowListener {
	MainFrame wframe;
	String strFireForest = new String("Bosque en llamas");
	String strWindForest = new String("Bosque de viento (Shimagore)");
	String strInit=new String("Inicia: ");
	
	JPanel IniPanel=new JPanel();
	JButton InitButton1=new JButton(strInit+strFireForest);
	JButton InitButton2=new JButton(strInit+strWindForest);
	
	FForest FF;
	WForest WF;
	
	public void init() {
		InitButton1.setBackground(SystemColor.activeCaptionBorder);
		InitButton2.setBackground(SystemColor.activeCaptionBorder);
		InitButton1.addActionListener(this);
		InitButton2.addActionListener(this);

		setLayout(new GridLayout(2,1,0,0));
		add(InitButton1);
		add(InitButton2);
		InitButton1.setEnabled(true);
		InitButton2.setEnabled(true);

		try {
			UIManager.setLookAndFeel(
              UIManager.getCrossPlatformLookAndFeelClassName());
			}
		catch (	Exception e) {}
	}
	

	public void actionPerformed(ActionEvent ae){
		if (!FForest.FFon && ae.getSource()==InitButton1) {
			FForest FF= new FForest(strFireForest);
			FF.addWindowListener(this);
		}
		if (!WForest.WFon && ae.getSource()==InitButton2) {
			WForest WF=new WForest(strWindForest);
			WF.addWindowListener(this);
		}
	}

	//don't use graphics on applet only buttons to frames
	public void paint(Graphics g) {
		getContentPane().paintComponents(g);
	}
		
	//only use this of window listener
	public void windowClosing(WindowEvent e){
		if (FForest.FFon) {
			FForest.FFon = false;
		}
		if (WForest.WFon) {
			WForest.WFon = false;
		}		
	}
	
	//Interface of window listener
	public void windowOpened(WindowEvent e) {}
	public void windowClosed(WindowEvent e) {}
	public void windowIconified(WindowEvent e){}
	public void windowDeiconified(WindowEvent e){}
	public void windowDeactivated(WindowEvent e){}
	public void windowActivated(WindowEvent e){}
}//End Class Forest